#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icons\prog.ico
#AutoIt3Wrapper_outfile=Pairs.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Pairs
#AutoIt3Wrapper_Res_Fileversion=1.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=(c) 2011 by Oscar
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ComboConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <ButtonConstants.au3>
#include <File.au3>
#include <GUIConstantsEx.au3>
Opt('GUIOnEventMode', 1) ; OnEvent-Mode einschalten

Global $sTitle = 'Pairs v1.2     ' & Chr(169) & ' by Oscar (www.autoit.de)'
Global $sIconDirRoot = @ScriptDir & '\icons\', $sIconDir
Global $aIcons, $ahButtons[36], $aCards[36], $aClick[2][2] = [[0,-1],[0,-1]], $iClick = 0, $iCount = 0, $iTimer

Global $aIconSet = _FileListToArray($sIconDirRoot, '*', 2), $sIconSet = ''
For $i = 1 To $aIconSet[0]
	$sIconSet &= $aIconSet[$i] & '|'
Next
$sIconSet = StringTrimRight($sIconSet, 1)
$sIconDir = $sIconDirRoot & '\' & $aIconSet[1] & '\'
Global $aIcons = _FileListToArray($sIconDir, '??.ico', 1)
If $aIcons[0] <> 19 Then Exit MsgBox(0, $sTitle, 'Icondateien nicht gefunden bzw. nicht vollstndig!')

$hGui = GUICreate($sTitle, 680, 510)
GUISetBkColor(0x222222)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetIcon($sIconDirRoot & 'prog.ico')

GUICtrlCreateGroup('', 5, 10, 485, 490)
For $i = 0 To 35
	$ahButtons[$i] = GUICtrlCreateButton('',  15 + Mod($i, 6) * 80, 25 + Int($i / 6) * 80, 64, 64, $BS_ICON)
	GUICtrlSetOnEvent(-1, '_ClickButton')
	GUICtrlSetState(-1, $GUI_HIDE)
Next
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateLabel('Kartenset auswhlen:', 500, 20, 200, 20)
GUICtrlSetColor(-1, 0xEEEEEE)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
$hSetSelect = GUICtrlCreateCombo('', 500, 45, 160, 30, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
GUICtrlSetData(-1, $sIconSet, $aIconSet[1])
GUICtrlSetOnEvent(-1, '_ChangeIconSet')

$hStart = GUICtrlCreateButton('Spiel starten', 500, 100, 160, 35)
GUICtrlSetFont(-1, 16, 800, 0, 'Times New Roman')
GUICtrlSetOnEvent(-1, '_SetCards')

GUICtrlCreateLabel('Zeit (sek.):', 505, 180, 85, 20)
GUICtrlSetColor(-1, 0xEEEEEE)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
$hTime = GUICtrlCreateLabel('0', 590, 180, 85, 20)
GUICtrlSetColor(-1, 0xEEEEEE)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')

GUICtrlCreateLabel('Karten (richtig):', 505, 220, 120, 20)
GUICtrlSetColor(-1, 0x66FF66)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
$hTrue = GUICtrlCreateLabel('0', 625, 220, 85, 20)
GUICtrlSetColor(-1, 0x66FF66)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')

GUICtrlCreateLabel('Karten (falsch):', 505, 260, 120, 20)
GUICtrlSetColor(-1, 0xFF6666)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
$hFalse = GUICtrlCreateLabel('0', 625, 260, 85, 20)
GUICtrlSetColor(-1, 0xFF6666)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')

$hCheats1 = GUICtrlCreateLabel('Cheats benutzt:', 505, 300, 120, 20)
GUICtrlSetColor(-1, 0xFFFF66)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
GUICtrlSetState(-1, $GUI_HIDE)
$hCheats2 = GUICtrlCreateLabel('0', 625, 300, 85, 20)
GUICtrlSetColor(-1, 0xFFFF66)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
GUICtrlSetState(-1, $GUI_HIDE)

GUISetState()

While True
	Sleep(20)
WEnd

Func _End()
	Exit
EndFunc

Func _ChangeIconSet()
	$sIconDir = $sIconDirRoot & '\' & GUICtrlRead($hSetSelect) & '\'
	$aIcons = _FileListToArray($sIconDir, '??.ico', 1)
	If $aIcons[0] <> 19 Then Exit MsgBox(0, $sTitle, 'Icondateien nicht gefunden bzw. nicht vollstndig!')
	For $i = 0 To 35
		If $i = $aClick[0][1] Or $i = $aClick[1][1] Then ContinueLoop
		GUICtrlSetImage($ahButtons[$i], $sIconDir & $aIcons[1])
	Next
EndFunc

Func _TimeDisplay()
	GUICtrlSetData($hTime, Int(TimerDiff($iTimer)/1000))
EndFunc

Func _ClickButton()
	Local $hButton = @GUI_CtrlId - $ahButtons[0]
	If $iClick = 1 And $hButton = $aClick[0][1] Then Return Beep(400, 200)
	$aClick[$iClick][0] = $aCards[$hButton]
	$aClick[$iClick][1] = $hButton
	GUICtrlSetImage($ahButtons[$hButton], $sIconDir & $aIcons[$aCards[$hButton] + 2])
	$iClick += 1
	If $iClick = 2 Then _CheckCards()
EndFunc

Func _CheckCards()
	Sleep(1000)
	If $aClick[0][0] = $aClick[1][0] Then
		GUICtrlSetState($ahButtons[$aClick[0][1]], $GUI_HIDE)
		GUICtrlSetState($ahButtons[$aClick[1][1]], $GUI_HIDE)
		GUICtrlSetData($hTrue, GUICtrlRead($hTrue) + 1)
		$iCount += 1
		If $iCount = 18 Then
			$iCount = 0
			HotKeySet('!c')
			AdlibUnRegister('_TimeDisplay')
			GUICtrlSetState($hStart, $GUI_ENABLE)
		EndIf
	Else
		GUICtrlSetImage($ahButtons[$aClick[0][1]], $sIconDir & $aIcons[1])
		GUICtrlSetImage($ahButtons[$aClick[1][1]], $sIconDir & $aIcons[1])
		GUICtrlSetData($hFalse, GUICtrlRead($hFalse) + 1)
	EndIf
	$aClick[0][1] = -1
	$aClick[1][1] = -1
	$iClick = 0
EndFunc

Func _SetCards()
	GUICtrlSetState($hStart, $GUI_DISABLE)
	Local $aRandom[36], $iRnd
	For $i = 0 To 17
		$aRandom[$i] = $i
		$aRandom[$i+18] = $i
	Next
	For $i = 0 To 35
		GUICtrlSetImage($ahButtons[$i], $sIconDir & $aIcons[1])
		GUICtrlSetState($ahButtons[$i], $GUI_SHOW)
		$iRnd = Random(0, 35 - $i, 1)
		$aCards[$i] = $aRandom[$iRnd]
		$aRandom[$iRnd] = $aRandom[35 - $i]
	Next
	GUICtrlSetData($hTrue, '0')
	GUICtrlSetData($hFalse, '0')
	GUICtrlSetData($hCheats2, '0')
	GUICtrlSetState($hCheats1, $GUI_HIDE)
	GUICtrlSetState($hCheats2, $GUI_HIDE)
	$iTimer = TimerInit()
	HotKeySet('!c', '_Cheat')
	AdlibRegister('_TimeDisplay', 1000)
EndFunc

Func _Cheat()
	GUICtrlSetState($hCheats1, $GUI_SHOW)
	GUICtrlSetState($hCheats2, $GUI_SHOW)
	GUICtrlSetData($hCheats2, GUICtrlRead($hCheats2) + 1)
	GUISetState(@SW_DISABLE)
	For $i = 0 To 35
		GUICtrlSetImage($ahButtons[$i], $sIconDir & $aIcons[$aCards[$i] + 2])
	Next
	Sleep(3000)
	For $i = 0 To 35
		If $i = $aClick[0][1] Or $i = $aClick[1][1] Then ContinueLoop
		GUICtrlSetImage($ahButtons[$i], $sIconDir & $aIcons[1])
	Next
	GUISetState(@SW_ENABLE)
EndFunc
